# -*- coding: utf-8 -*-

# SWGui - Einfache GUI-Programmierung
# Opensource
# Autoren R. Oldenburg, M. Rabel, J. Schuster, Uni Frankfurt 
# Kontakt oldenbur@math.uni-frankfurt.de

# QT-Version von SWGui

# Import & Init .........................................................



# to button mit Bildern
# tabelle ohne header

from PyQt4 import QtGui
from PyQt4 import Qt
from PyQt4 import QtCore
from PyQt4 import QtWebKit


import math
import sys,os

TheCursor=None

def SWclose(): 
    """Schließt das SWGui Fenster

    Die QT-Infrastruktur bleibt erhalten."""
    print "Entering swclose"
    try: TheMainWin.close()
    except: print "TheWin not closed"
    try: QtCore.pyqtRemoveInputHook()
    except: print "Hook not removed"
    try: 
        TheApp.exit()
        del TheApp
    except: print "The App not destroyed"

def SWstart(): 
    """Startet die Ereignisbehhandlung von QT

    SWstart braucht in der Regel NICHT aufgerufen zu werden. 
    unter IDLE ist es nötig."""
    TheMainWin.show()
    return TheApp.exec_()

def SWinteract():
    """Ermöglicht die Ereignisbehhandlung von QT

    SWinteract benötigt man in Programmen, die eine eigene Endlosschleife implementieren, 
    so dass die QT-Ereignisse nicht verarbeitet werden können. 
    Gelegentlich Aufruf von SWinteract erlaubt dann die Event-Behandlung und aktualisiert
    das Fesnter."""
    TheMainWin.update()
    TheApp.processEvents()

def SWclear():
    """Löscht alle Elemente des Hauptfensters

    Nach SWclear können neue Widgets erzeugt werden."""
    global TheWin,TheCursor,TheMainContainer
    TheWin=QtGui.QWidget()
    TheMainWin.setCentralWidget(TheWin)
    TheWin.TheLayout=QtGui.QVBoxLayout()
    TheMainContainer=TheWin.TheLayout
    TheWin.setLayout(TheWin.TheLayout)
    TheWin.show()
    TheCursor=TheWin.TheLayout

SWKeyTable={
    QtCore.Qt.Key_Left:"left",
    QtCore.Qt.Key_Right:"right",
    QtCore.Qt.Key_Up:"up",
    QtCore.Qt.Key_Down:"down",
    QtCore.Qt.Key_Tab:"tab",
    QtCore.Qt.Key_Return:"return"
    }


class SWWidget(QtGui.QWidget):
    def __init__(self): 
        QtGui.QWidget.__init__(self)
        self.commands={}
        self.anyKeyCommand=None
    def keyPressEvent(self,event):
        if SWKeyTable.has_key(event.key()):  
            te=SWKeyTable[event.key()]
        else: te=str(event.text())
        if self.commands.has_key(te):
            if self.commands[te]!=None:
                return self.commands[te]()
        else:
            if self.anyKeyCommand==None: return
            self.anyKeyCommand(te)
    def setKeyCommand(self,key,cmd): self.commands[key]=cmd

def setKeyCommand(key,cmd):
    """setKeyCommand(key, cmd) -  Befehhl cmd, wenn Taste key
    
    cmd ist eine parameterlose Funktion. key ist ein String, zB
    'a' oder 'A' oder 'CTRL-Z' oder 'return'
    Beispiel: setKeyCommand('x', cmd) """ 
    global TheWin
    if type(key)==str:
        if key.startswith("CTRL-") and len(key)>=6:
            key=chr(ord(key[5].upper())-64)
            print "Key set", key
    TheWin.setKeyCommand(key,cmd)

def setAnyKeyCommand(cmd): 
    """setAnyKeyCommand(kcmd) -  Befehhl cmd, wenn beliebige Taste
    
    cmd ist eine parameterlose Funktion""" 
    global TheWin
    TheWin.anyKeyCommand=cmd
    
    
def SWinit():
    global TheApp,TheMainWin,TheWin,TheCursor,TheMainContainer
    TheApp = QtGui.QApplication([])
    TheApp.setQuitOnLastWindowClosed(True)
    TheMainWin=QtGui.QMainWindow()
    #TheWin=QtGui.QWidget()
    TheWin=SWWidget()
    TheMainWin.setCentralWidget(TheWin)
    TheWin.TheLayout=QtGui.QVBoxLayout()
    TheWin.setLayout(TheWin.TheLayout)
    TheMainContainer=TheWin.TheLayout
    #TheWin.show()
    TheCursor=TheWin.TheLayout
    TheMainWin.connect(TheWin, QtCore.SIGNAL("closed()"),SWclose)

def SWshow(*args):
    """SWshow() zeigt das SWGui-Fenster an
    
    """
    args=list(args)
    if args==[]: TheMainWin.show()
    else: 
        if args[0]==True: TheMainWin.show()
        else: TheMainWin.hide()


try: 
    TheMainWin0=TheMainWin # Wenn das keinen Fehler auslöst, dann Warmstart
    del TheApp
except: 
    SWinit()

SWCursorStack=[TheCursor]

def SWLastContainer():
    """SWLastContainer() wechselt den aktuellen Container zum vorhergehenden
    
    Neue Widgets werden dann in den davor aktuellen Container gesetzt"""
    global TheCursor,SWCursorStack
    if len(SWCursorStack)>1:
        TheCursor=SWCursorStack[1]
        SWCursorStack=SWCursorStack[1:]

def SWsetWindowTitle(s): 
    """SWsetWindowTitle(s) setzt den Titel des Fensters
      
    """
    assert isinstance(s,str) or isinstance(s,unicode) 
    TheMainWin.setWindowTitle(s)

def SWsetWindowIcon(i): 
    """SWsetWindowIcon(i) setzt das Icon des fensters
      
    i kann sein ein Dateiname einer Bilddatei oder ein QT-Pixelbild"""
    TheMainWin.setWindowIcon(QtGui.QIcon(i))

def SWsetWidgetSize(widget,breite,hoehe):
    """SWsetWidgetSize(widget,breite,hoehe) setzt die Groesse eines Widgets
      
    """
    assert isinstance(breite,int)
    assert isinstance(hoehe,int)
    assert breite>=0
    assert hoehe>=0
    rect=widget.geometry()
    widget.setGeometry(rect.x(),rect.y(),breite,hoehe)

def SWsetWindowSize(breite,hoehe): 
    """SWsetWindowSize(breite,hoehe) setzt die Groesse des Fensters
      
    """
    assert isinstance(breite,int)
    assert isinstance(hoehe,int)
    assert breite>=0
    assert hoehe>=0
    rect=TheMainWin.geometry()
    TheMainWin.setGeometry(rect.x(),rect.y(),breite,hoehe)


# Tools fuer Farben ................................................
SWColMap={"red": [255,0,0], "green": [0,255,0], "blue": [0,0,255],
          "black": [0,0,0], "white": [255,255,255], "gray": [128,128,128],
          "yellow": [255,255,0], "magenta": [255,0,255], "cyan":[0,255,255] }  
          
def mkQCol(col): 
    """mkCol(col) erzeugt eine Farbe aus verschiedenen Angaben
    
    col kann sein eine Zeichenkette "black", "red",...., eine RGB-Liste [255,0,255],
    oder eine 32-Bit-Zahl"""
    if col==None: return col
    if type(col)==QtGui.QColor: return col
    if type(col)==long: return QtGui.QColor(col)
    if type(col)==str:
        if col in SWColMap.keys(): col=SWColMap[col]
        else: raise Exception("Unkonwn Color string: "+col)
    if type(col)==int or type(col)==float: col=[col,col,col]
    col=map(int,col)
    if len(col)==3: return apply(QtGui.QColor.fromRgb,col)
    if len(col)==4: return apply(QtGui.QColor.fromRgba,col)
    raise(TypeError("No Color: "+str(col)))
def mkQColNum(col): 
    if type(col)==int and col>1000: return col
    else: return mkQCol(col).rgba()
  

# Widget Klassen .....................................................
class SWVBox(QtGui.QVBoxLayout):
    """SWVBox ist ein Contaner, der Widgets vertikal anordnet
    
    SWVBox() erzeugt eine Box an der aktuellen Cursorposition
    SWVBox(c)erzeugt eine Box innerhalb eines anderen Containers"""
    def __init__(self,container=None):
        global TheCursor,SWCursorStack
        QtGui.QVBoxLayout.__init__(self)
        if container==None: self.layout = TheCursor
        else: self.layout =container
        self.layout.addLayout(self)
        TheCursor=self
        SWCursorStack=[self]+SWCursorStack

class SWHBox(QtGui.QHBoxLayout):
    """SWHBox ist ein Contaner, der Widgets vertikal anordnet
    
    SWHBox() erzeugt eine Box an der aktuellen Cursorposition
    SWHBox(c)erzeugt eine Box innerhalb eines anderen Containers"""
    def __init__(self,container=None):
        global TheCursor,SWCursorStack
        QtGui.QHBoxLayout.__init__(self)
        if container==None: self.layout = TheCursor
        else: self.layout =container
        self.layout.addLayout(self)
        TheCursor=self
        SWCursorStack=[self]+SWCursorStack


class SWButton(QtGui.QPushButton): # Text setzen mit setText
    """SWButton : Button-Klasse
    
    SWButton(container=None,text='', command=None)
    command ist eine Funktion mit einem oder keinem Argument,
    die aufgerufen wird, wenn der Button gedrueckt wird.
    Es wird der Button selbst als Argument uebergeben.
    """
    def __init__(self, text='', container=None, command=None, **options):
        assert isinstance(text,str) or isinstance(text,unicode)
        QtGui.QPushButton.__init__(self,text)
        self.setCommand(command)
        if container==None: self.layout = TheCursor
        else: self.layout =container
        self.layout.addWidget(self)
        self.command=command
        self.clicked.connect(self.cmd)
    def cmd(self,ignored): 
        if self.command!=None:
            try: self.command(self)
            except TypeError:
                self.command()
    def setCommand(self,cmd):
        """Setzt die Aktion, die ein Button bewirkt

        cmd wird bei Klick auf den Buton aufgerufen (1 Argumentm der Button selbst),
        oder kein Argument."""
        self.command=cmd
        #if cmd!=None: self.clicked.connect(cmd)
    def setSize(self,w,h):
        """setSize(w,h) setzt breite und hoehe des Widgets
        
        """
        assert isinstance(w,int)
        assert isinstance(h,int)
        return self.resize(w,h) # setValue  ererbet
    def getText(self):
        """getText() liefert den Text auf einem Button
        
        
        """
        return str(self.text())

class SWCheckBox(QtGui.QCheckBox): # isChecked() to query; setChecked(bool)  
    def __init__(self, text="",container=None, command=None, **options):
        QtGui.QCheckBox.__init__(self,text)
        self.command=command
        self.stateChanged.connect(self.cmd)
        if container==None: self.layout = TheCursor
        else: self.layout =container
        self.layout.addWidget(self)
    def cmd(self,*arg): 
        if self.command!=None:
            try: self.command(self.isChecked(),self)
            except TypeError:
                try: self.command(self.isChecked())
                except TypeError:
                    try: self.command()
                    except: pass                
    def setText(self,s):
        """Setzt den Text einer Checkbox

        s kann ein beliebiger String sein"""
        assert isinstance(s,str) or isinstance(s,unicode)
        self.setText(s)
    def setCommand(self,s): 
        """Setzt die Aktion, die eine Checkbox bewirkt

        cmd bekommt zwei Argumente (checked?,Checkbox), eines (checked?),
        oder keins."""
        self.command=s


class SWSlider(QtGui.QSlider):
    def __init__(self, orient, min, start,max,container=None, command=None):
        if orient in ["h","H","Horizontal","horizontal"]: 
            QtGui.QSlider.__init__(self,0x1)
            self.dir="h"
        else: 
            QtGui.QSlider.__init__(self,0x2)
            self.dir="v"
        self.setRange(min,max)
        self.setValue(start)
        self.setTickPosition(2)
        self.command=command
        self.valueChanged.connect(self.cmd)
        if container==None: self.layout = TheCursor
        else: self.layout =container
        self.layout.addWidget(self)
    def cmd(self,*arg): 
        if self.command!=None:
            try: self.command(self.value(),self)
            except TypeError:
                try: self.command(self.value())
                except TypeError:
                    try: self.command()
                    except: pass                
    def setCommand(self,s): 
        """Setzt die Aktion, die beim Schieben des Sliders ausfgerufen wird

        cmd bekommt zwei Argumente (wert,slider) oder eines (wert),
        oder kein Argument haben."""
        self.command=s
    def getValue(self):  # Parallel dazu setValue
        """getValue() liefert den Wert eines Sliders
        
        """
        return self.value() # setValue  ererbet
    def setSize(self,w,h):
        """setSize(w,h) setzt breite und hoehe des Widgets
        
        """
        return self.resize(w,h) # setValue  ererbet

class SWTextField(QtGui.QLineEdit):
    """SWTextField Ein/Ausgabezeile fuer Text
    
    """
    # Ererbt: setMaxLength(c)
    def __init__(self, container=None,text='', command=None,**options):
        QtGui.QLineEdit.__init__(self,text)
        self.setCommand(command)
        if container==None: self.layout = TheCursor
        else: self.layout =container
        self.layout.addWidget(self)
        self.command=command
        self.returnPressed.connect(self.cmd)
    def cmd(self):
        if self.command!=None:
            try: self.command(self)
            except TypeError:
                self.command()
    def setCommand(self,cmd):
        """Setzt die Aktion bei Enter-Taste im TextField

        cmd wird bei im TextField aufgerufen (1 Argument, das TextField selbst),
        oder kein Argument."""
        self.command=cmd
        #if cmd!=None: self.clicked.connect(cmd)
    def getText(self): return str(self.text()) # setText  ererbt
    def getFloat(self):
        try:
            return float(str(self.text()))
        except: return float("nan")
    def getInt(self):
        try:
            return int(str(self.text()))
        except: return float("nan")
    def getEval(self):
        try:
            return eval(str(self.text()))
        except: return None


class SWTextEdit(QtGui.QTextEdit):
    """SWTextEdit Ein/Ausgabe fuer Text
    
    """
    # Ererbt: setMaxLength(c)
    def __init__(self, container=None,text='', command=None,**options):
        QtGui.QTextEdit.__init__(self,text)
        self.setCommand(command)
        if container==None: self.layout = TheCursor
        else: self.layout =container
        self.layout.addWidget(self)
        self.command=command
        self.textChanged.connect(self.cmd)
    def cmd(self):
        if self.command!=None:
            try: self.command(self)
            except TypeError:
                self.command()
    def setCommand(self,cmd):
        """Setzt die Aktion bei Enter-Taste im TextEdit

        cmd wird bei Enter im TextEdit aufgerufen (1 Argument, das TextField selbst),
        oder kein Argument."""
        self.command=cmd
        #if cmd!=None: self.clicked.connect(cmd)
    def getText(self): return str(self.toPlainText()) # setText  ererbt



class SWHTMLDisplay(QtWebKit.QWebView):
    """SWHTMLDisplay zeigt HTML an
    
    """
    # Ererbt: setMaxLength(c)
    def __init__(self, container=None,text='', command=None):
        QtWebKit.QWebView.__init__(self)
        if container==None: self.layout = TheCursor
        else: self.layout =container
        self.layout.addWidget(self)
        self.setText(text)
        self.page().setLinkDelegationPolicy(QtWebKit.QWebPage.DelegateAllLinks)
        self.linkClicked.connect(lambda b: self.cmd(b))
        self.command=command
    def setText(self,text): 
        assert isinstance(text,str) or isinstance(text,unicode)
        self.setHtml(text)
    def getText(self): return str(self.toPlainText()) # setText  ererbt
    def setCommand(self,cmd):
        """Setzt die Aktion bei Klick auf einen Link 

        cmd wird bei Klick auf Link aufgerufen (2 Argument: self und  Link),
        oeder ein Argument (Link) oder kein Argument."""
        self.command=cmd
    def cmd(self,*arg):
        try: url=str(arg[0].toString())
        except: url=unicode(arg[0].toString())
        url=unicode(arg[0].toString())
        #print "cmd", url
        if self.command!=None:
            try: self.command(self,url)
            except TypeError:
                try: self.command(url)
                except TypeError:
                    try: self.command()
                    except: pass                





class SWLabel(QtGui.QLabel):
    def __init__(self, text="",container=None, **options):
        QtGui.QLabel.__init__(self,text)
        if container==None: self.layout = TheCursor
        else: self.layout =container
        self.layout.addWidget(self)
    def setOrientation(self,dir): #??????
        if dir.upper()=="L": self.setAlignment(QtCore.Alignment(0));
        if dir.upper()=="R": self.setAlignment(QtCore.Alignment(1));
        if dir.upper()=="C": self.setAlignment(QtCore.Alignment(2));
    def getText(self):
        """getText() liefert den Text auf einem Button
        
        
        """
        return str(self.text())


class SWComboBox(QtGui.QComboBox):
    def __init__(self, ItemList=[],command=None, container=None, **options):
        QtGui.QComboBox.__init__(self)
        if container==None: self.layout = TheCursor
        else: self.layout =container
        self.layout.addWidget(self)
        for x in ItemList: self.addItem(x)
        self.currentIndexChanged.connect(lambda i: self.cmd(i))
        self.command=command
        
    def setCommand(self,cmd):
        """Setzt die Aktion bei Wahl eines neuen Items aus der ComboBox 

        cmd wird mit 3 Argumenten aufgerufen: Die Box, der Index und das Item,
        oder mit 2 Argumenten: Box, Item, 
        oder mit einem Argument: Item
        oder ohne Argumente"""
        self.command=cmd
    def cmd(self,i):
        if self.command!=None: self.command(self,i,self.currentText())
    def cmd(self,*arg): 
        if self.command!=None:
            try: self.command(self,i,self.currentText())
            except TypeError:
                try: self.command(self,self.currentText())
                except TypeError:
                    try: self.command(self.currentText())
                    except TypeError:
                        try: self.command()
                        except: pass                

# Direkt von QCombonBox geerbt und nützlich
# currentText(), currentIndex(), addItem(text), removeItem(index)
# insertitem(index,text), count(),...    
        


class SWList(QtGui.QListWidget):   
    # addItem interessant
    def __init__(self, zeilen=0,container=None, command=None, **options):
        QtGui.QListWidget.__init__(self)
        for i in range(zeilen): self.addItem("")
        if container==None: self.layout = TheCursor
        else: self.layout =container
        self.layout.addWidget(self)
        self.setChangedCommand(command)
        self.setClickCommand(command)
        self.itemClicked.connect(self.clickCMD)
        self.itemChanged.connect(self.changeCMD)
    def setChangedCommand(self,s): # Kommando bekommt table, zeile
        """setChangedCommand setzt den Befehl, der beim Editieren aufgerufen wird
        
        Die übergebene Funktion nimmt entweder kein Argument oder zwei (sich selbst und Zeile)"""
        self.chCMD=s
    def setClickCommand(self,s): # Kommando bekommt table zeile 
        """setClickCommand setzt den Befehl, der beim KLicken aufgerufen wird
        
        Die übergebene Funktion nimmt entweder kein Argument oder zwei (sich selbst und Zeile)"""
        self.clCMD=s
    def changeCMD(self,qlwi):
        if self.chCMD!=None: 
            try: self.chCMD(self,self.ze(qlwi))
            except TypeError:
                self.chCMD()
    def clickCMD(self,qlwi):
        if self.clCMD!=None: 
           try: self.clCMD(self,self.ze(qlwi))
           except TypeError:
                self.clCMD()
    def ze(self,item): # Gibt Nummer des Items
        for i in range(self.count() ):
            if QtGui.QListWidget.item(self,i)==item: return i
        return -1
    def addItems(self,list): 
        for x in list: self.addItem(x)
    def setItem(self,z,text):
        assert isinstance(text,str) or isinstance(text,unicode)
        assert isinstance(z,int)
        if type(text)!=str and type(text)!=unicode: text=str(text)
        QtGui.QListWidget.setItem(self,z,QtGui.QListWidgetItem(text))
    def getItem(self,z): 
        assert isinstance(z,int)
        try: return str(self.item(z).data(0).toString())
        except: return ""
    def getItems(self):
        Z=self.count() 
        return [self.getItem(z) for z in range(Z)]


class SWTable(QtGui.QTableWidget):   
    def __init__(self, zeilen,spalten,container=None, command=None, **options):
        QtGui.QTableWidget.__init__(self,zeilen,spalten)
        if container==None: self.layout = TheCursor
        else: self.layout =container
        self.layout.addWidget(self)
        self.setChangedCommand(command)
        self.setRowHeaders(["Zeile "+str(i) for i in range(zeilen)])
        self.setColHeaders(["Spalte "+str(i) for i in range(spalten)])
    def newRow(self,zeile,titel=""):
        self.insertRow(zeile)
        self.setRowHeaders(self.RowHeaders[:zeile]+[titel]+self.RowHeaders[zeile:])
    def newCol(self,sp,titel=""):
        self.insertColumn(sp)
        self.setColHeaders(self.ColHeaders[:sp]+[titel]+self.ColHeaders[sp:])
    def setChangedCommand(self,s): # Kommando bekommt zeile und spalte
        if s!=None:
            self.cellChanged.connect(lambda ze,sp: s(ze,sp))
    def setClickCommand(self,s): # Kommando bekommt zeile und spalte
        if s!=None:
            self.cellClicked.connect(lambda ze,sp: s(ze,sp))
    def setClickedCommand(self,s): # Kommando bekommt zeile und spalte
        if s!=None:
            self.cellClicked.connect(lambda ze,sp: s(ze,sp))
    def setItem(self,z,s,text):
        if type(text)!=str: text=str(text)
        assert isinstance(s,int)
        assert isinstance(z,int)
        QtGui.QTableWidget.setItem(self,z,s,QtGui.QTableWidgetItem(text))
    def getItem(self,z,s): 
        assert isinstance(s,int)
        assert isinstance(z,int)
        try: return str(self.item(z,s).data(0).toString())
        except: return ""
    def getItemsTransposed(self):
        Z=self.rowCount() 
        S=self.columnCount()
        return [[self.getItem(z,s) for z in range(Z)] for s in range(S)]
    def getItems(self):
        Z=self.rowCount() 
        S=self.columnCount()
        return [[self.getItem(z,s) for s in range(S)] for z in range(Z)]
    def setColHeaders(self,namelist):
        self.ColHeaders=namelist
        self.setHorizontalHeaderLabels(namelist)
    def setRowHeaders(self,namelist): 
        self.RowHeaders=namelist
        self.setVerticalHeaderLabels(namelist)
    def setBackgroundColor(self, z,s, col):
        self.item(z,s).setBackgroundColor(mkQCol(col))
    def setTextColor(self, z,s, col):
        self.item(z,s).setTextColor(mkQCol(col))
    def setFontSize(self, *args):
        args=list(args)
        if len(args)==3: 
            [z,s,n]=args
            self.item(z,s).setFont(QtGui.QFont("Arial",pointSize=n))
        else: 
            if len(args)==1: 
                n=int(args[0])
                for z in range(self.rowCount()):
                    for s in range(self.columnCount()): 
                        self.item(z,s).setFont(QtGui.QFont("Arial",pointSize=n))
        self.update()
    def minimumSizeHint(self): 
        return QtCore.QSize(self.columnCount()*80+40, 50+self.rowCount()*20)
    def showHorizontalHeader(self,yesno):
        if yesno: self.horizontalHeader().show()
        else: self.horizontalHeader().hide()
    def showVerticalHeader(self,yesno):
        if yesno: self.verticalHeader().show()
        else: self.verticalHeader().hide()
    



# Dialoge -------------------------------------------------------------

def SWColorDialogQ(): # Gibt QT-Farbe
    """SWColorDialogQ() opend a choose color dialog
    
    Returns a PyQT Color object"""
    (f,ok)= QtGui.QColorDialog.getRgba()
    if not(ok): return None
    return  mkQCol(f)

def  SWColorDialog(): # Gibt Liste der RGB-Werte
    """SWColorDialog() opend a choose color dialog
    
    Returns a list of RGB values"""
    (f,ok)= QtGui.QColorDialog.getRgba()
    if not(ok): return None
    col=mkQCol(f)
    return [col.red(),col.green(),col.blue()]

def SWFileDialog(title="Select File",dir=None):
    """SWFileDialog(title="Select File",dir=None) - shows a file select dialog
    
    The optional argument dir specifies the start directory.
    Return value is a string (filename with path)"""
    if dir==None:
        s=str(QtGui.QFileDialog.getOpenFileName(caption=title))
        if s=="": return None
        else: return s
    else: 
        s=str(QtGui.QFileDialog.getOpenFileName(caption=title,directory=dir))
        if s=="": return None
        else: return s

def SWWarning(text): 
    """SWWarning(text) - shows a message box
    
    text may contain HTML tags"""
    if not(isinstance(text,str)): text=str(text)
    QtGui.QMessageBox.warning(TheWin,"SWWarning",text)

def SWYesNoDialog(text): # Liefert boolean
    """SWYesNoDialog(text) - shows a message box and yes/no question
    
    text may contain HTML tags. Returns True or False"""
    if not(isinstance(text,str)): text=str(text)
    return 0==QtGui.QMessageBox.question(TheWin,"?",text,"yes","no")


class SWPromptDialog(QtGui.QDialog):
    def __init__(self,question,initText):
        QtGui.QDialog.__init__(self)
        L=QtGui.QLabel(question)
        layout=QtGui.QVBoxLayout()
        layout.addWidget(L)
        self.tf=QtGui.QLineEdit()
        self.tf.setText(initText)
        layout.addWidget(self.tf)
        okButton=QtGui.QPushButton("OK")
        cancelButton=QtGui.QPushButton("cancel")
        buLayout=QtGui.QHBoxLayout()
        buLayout.addWidget(okButton)
        buLayout.addWidget(cancelButton)
        layout.addLayout(buLayout)
        self.setLayout(layout)
        self.connect(okButton,Qt.SIGNAL("clicked()"),self,Qt.SLOT("accept()"))
        self.connect(cancelButton,Qt.SIGNAL("clicked()"),self,Qt.SLOT("reject()"))
        self.setWindowTitle("Enter")
    def getText(self): return str(self.tf.text())

def SWTextDialog(question,initText="",oktest=None,converter=None):
    """SWTextDialog(question,initText="",oktest=None,converter=None)
    
    SWTextDialog opens a dialog that asks for a text string.
    initText, if given, is the text initially contaied in the field.
    optest, if given, is a function of oone argument that is called to
    check wheter the inpou is valid
    converter, if given, is a function that is applied before return.
    Example:  SWTextDialog('Enter number', converter=int) gives a number"""
    d=SWPromptDialog(question,initText)
    while True:
        if d.exec_()==0: return None
        r=d.getText()
        if oktest==None: 
            if converter==None: return r
            else: return converter(r)
        if oktest(r):
            if converter==None: return r
            else: return converter(r)
            
def isIntStr(s):
    try:
        i=int(s)
    except: return False
    return True
def isFloatStr(s):
    try:
        i=float(s)
    except: return False
    return True
    
def SWIntDialog(question,init=0):
    """SWIntDialog(question,init=0) ask for an Integer
    
    """
    return SWTextDialog(question,str(init),isIntStr,int)     

def SWFloatDialog(question,init=0.0):
    """SWFloatDialog(question,init=0.0) ask for a Floating point number
    
    """
    return SWTextDialog(question,str(init),isFloatStr,float)     


#- Bitmapgraphics

class SWImage(QtGui.QWidget):
    def __init__(self, width=None,height=None,container=None, file=None, dim=[200,200], parent=None):
        QtGui.QWidget.__init__(self,parent)
        if not(width==None) and not(height==None): dim=[width,height]
        self.pen = QtGui.QPen()
        self.brush = QtGui.QBrush()
        self.viewport=[-10,10,-10,10] # [xmin,xmax,ymin,ymax]
        if file!=None:
            self.image= QtGui.QImage(file)
            self.setMinimumWidth(self.image.width())
            self.setMinimumHeight(self.image.height())
            self.painter=QtGui.QPainter(self.image)
            self.painter.drawImage(0, 0, self.image,sx=0,sy=0)
            self.update()
            self.dim=[self.image.width(),self.image.height()]
        else:
            self.setMinimumWidth(dim[0])
            self.setMinimumHeight(dim[1])
            self.image= QtGui.QImage(dim[0],dim[1],4) # 4=RGB
            self.painter=QtGui.QPainter(self.image)
            self.image.fill(mkQColNum([255,255,255]))
            self.dim=dim
            self.update()
        self.myColor=mkQCol("black")
        if container==None: self.layout = TheCursor
        else: self.layout =container
        self.layout.addWidget(self)
        self.mousePressCommand=None
        self.mouseReleaseCommand=None
        self.mouseDragCommand=None
    def W2S(self,xy):
        assert isinstance(xy,list)
        assert len(xy)==2
        [xw,yw]=xy
        [xmin,xmax,ymin,ymax]=self.viewport
        return [int(float(self.getWidth())*float(xw-xmin)/float(xmax-xmin)),
                int(float(self.getHeight())*float(ymax-yw)/float(ymax-ymin))]
    def S2W(self,xy):
        assert isinstance(xy,list)
        assert len(xy)==2
        [xs,ys]=xy
        [xmin,xmax,ymin,ymax]=self.viewport
        return [xmin+(xmax-xmin)*xs/float(self.getWidth()),
                ymax-(ymax-ymin)*ys/float(self.getHeight())]
    def setActive(self,value):
        self.setUpdatesEnabled(value) 
        if value: self.update()
    def save(self,filename):
        """save(dateiname) speicher das Bild in einer Datei
        
        """
        self.image.save(filename)
    def minimumSizeHint(self): return QtCore.QSize(20, 20)
    def sizeHint(self): return QtCore.QSize(400, 200)
    def paintEvent(self, event):
        painter=QtGui.QPainter(self)
        painter.drawImage(0, 0, self.image)
        painter.end()
    def getHeight(self): return self.image.height()    
    def getWidth(self): return self.image.width()
    def setColor(self,col): self.myColor=mkQCol(col)    
    def load(self,filename): 
        assert isinstance(filename,str)
        try:
            self.painter.end()
        except: pass
        self.image.load(filename)
        self.setMinimumWidth(self.image.width())
        self.setMinimumHeight(self.image.height())
        self.painter=QtGui.QPainter(self.image)
        self.painter.drawImage(0, 0, self.image,sx=0,sy=0)
        self.update()
    def getPixel(self, x, y):
        """getPixel(x,y)    Gibt eine [R,G,B]-Liste der Farbe an Position x,y
        
        """
        if isinstance(x,float): x=int(x)
        if isinstance(y,float): y=int(y)
        assert isinstance(x,int)
        assert isinstance(y,int)
        w=self.image.pixel(x,y)
        return [int((w/(256*256))%256), int((w/256)%256), int(w%256)]
    def getPixelGray(self, x, y):
        """getPixelGray(x,y)    Gibt den Helligkeitswert  der Farbe an Position x,y
        
        """
        if isinstance(x,float): x=int(x)
        if isinstance(y,float): y=int(y)
        assert isinstance(x,int)
        assert isinstance(y,int)
        col=QtGui.QColor(self.image.pixel(x,y))
        return (col.red()+col.green()+col.blue())/3
    def getPixelQ(self, x, y):
        """getPixelQ(x,y)    Gibt das QColor-Objekt der Farbe an Position x,y
        
        """
        return QtGui.QColor(self.image.pixel(x,y))
    def setPixelW(self,x,y,col=None):
        assert isinstance(x,int) or isinstance(x,float)
        assert isinstance(y,int) or isinstance(y,float)
        [xx,yy]=self.W2S([x,y])
        self.setPixel(xx,yy,col)
    def setPixel(self,x,y,col=None):
        """setPixel(x,y,farbe)
        
        Setzt die Farbe an Position x,y auf farbe (optional).""" 
        if isinstance(x,float): x=int(x)
        if isinstance(y,float): y=int(y)
        assert isinstance(x,int)
        assert isinstance(y,int)
        if col==None:
            self.image.setPixel(x,y,mkQColNum(self.myColor))
        if type(col)==list and len(col)==3:
            self.image.setPixel(x,y,int(256*256*256*255+256*256*col[0]+256*col[1]+col[2]))
        else:
            self.image.setPixel(x,y,mkQColNum(col))
    def fill(self,col=None):
        if col==None: self.image.fill(self.myColor)
        else: self.image.fill(mkQColNum(col))
    def drawPoint(self,x,y,col=None):
        if isinstance(x,float): x=int(x)
        if isinstance(y,float): y=int(y)
        assert isinstance(x,int)
        assert isinstance(y,int)
        if col==None: self.painter.setPen(self.myColor)
        else: self.painter.setPen(mkQCol(col))
        self.painter.drawPoint(x,y)
    def drawLine(self,x0,y0,x1,y1,col=None):
        if col==None: self.painter.setPen(self.myColor)
        else: self.painter.setPen(mkQCol(col))
        self.painter.drawLine(x0,y0,x1,y1)
    def drawLineW(self,x0,y0,x1,y1,col=None):
        [X0,Y0]=self.W2S([x0,y0])
        [X1,Y1]=self.W2S([x1,y1])
        self.drawLine(X0,Y0,X1,Y1,col)
    def drawCircleW(self,xm,ym,r,col=None,filled=False):
        [x,y]=self.W2S([xm,ym])
        x1=self.W2S([xm+r,ym])[0]
        y1=self.W2S([xm,ym+r])[1]
        rr=int(math.sqrt((x1-x)**2+(y1-y)**2))
        self.drawCircle(x,y,rr,col,filled)
    def drawCircle(self,xm,ym,r,col=None,filled=False): 
        self.drawEllipse(xm-r,ym-r,2*r,2*r,col,filled)
    def drawEllipse(self,x0,y0,xd,yd,col=None,filled=False): 
        if col==None: self.painter.setPen(self.myColor)
        else: self.painter.setPen(mkQCol(col))
        if filled and col==None: self.painter.setBrush(self.myColor)
        if filled and col!=None: self.painter.setBrush(mkQCol(col))
        if not(filled): 
            self.brush.setStyle(0)
            self.painter.setBrush(self.brush)
        self.painter.drawEllipse(x0,y0,xd,yd)
    def drawRectW(self,x0,y0,xd,yd,col=None,filled=False):
        [X0,Y0]=self.W2S([x0,y0])
        [X1,Y1]=self.W2S([x0+xd,y0+yd])
        self.drawRect(X0,Y0,X1-X0,Y1-Y0,col,filled)        
    def drawRect(self,x0,y0,xd,yd,col=None,filled=False): 
        if col==None: self.painter.setPen(self.myColor)
        else: self.painter.setPen(mkQCol(col))
        if filled and col==None: self.painter.setBrush(self.myColor)
        if filled and col!=None: self.painter.setBrush(mkQCol(col))
        if not(filled): 
            self.brush.setStyle(0)
            self.painter.setBrush(self.brush)
        self.painter.drawRect(x0,y0,xd,yd)
    def drawTextW(self,x0,y0,t,col=None):
        [x,y]=self.W2S([x0,y0])
        self.drawText(x,y,t,col)
    def drawText(self,x0,y0,t,col=None): 
        if col==None: self.painter.setPen(self.myColor)
        else: self.painter.setPen(mkQCol(col))
        self.painter.drawText(x0,y0,QtCore.QString(t))
    def getTurtle(self): return SWTurtle(self)
    # Eventhandler nehmen zwei Argumente: widget, event (mit X und Y Feldern)
    def setMousePressCommand(self,s): self.mousePressCommand=s
    def setMouseReleaseCommand(self,s): self.mouseReleaseCommand=s
    def setMouseDragCommand(self,s): self.mouseDragCommand=s
    def setMouseMoveCommand(self,s): self.mouseDragCommand=s
    def mousePressEvent(self, event): 
        if self.mousePressCommand!=None: 
            try:
                event.X=int(event.x())
                event.Y=int(event.y())
                self.mousePressCommand(self,event)
            except: print "Fehler in mousePressEvent"
    def mouseReleaseEvent(self, event):
        if self.mouseReleaseCommand!=None: 
            try: 
                event.X=int(event.x())
                event.Y=int(event.y())
                self.mouseReleaseCommand(self,event)
            except: print "Fehler in mouseReleaseEvent"
    def mouseMoveEvent(self, event):
        if self.mouseDragCommand!=None: 
            try:
                event.X=int(event.x())
                event.Y=int(event.y())
                self.mouseDragCommand(self,event)
            except: print "Fehler in mouseMoveEvent"
    
class SWTurtle:
    def __init__(self,BM):
        """Erzeuge eine Turtle auf eienm SWImage

        BM ist eine Bitmap vom Typ SWImage"""
        self.BM=BM
        self.turtle=[BM.image.width()/2,BM.image.height()/2,0,True,
                     mkQColNum("black")]
    def left(self,alpha): 
        """Drehen der Turtle

        alpha ist der Drehwinkel"""
        assert isinstance(alpha,int) or isinstance(alpha,float)
        self.turtle[2]=self.turtle[2]-alpha
    def right(self,alpha): 
        """Drehen der Turtle

        alpha ist der Drehwinkel"""
        assert isinstance(alpha,int) or isinstance(alpha,float)
        self.turtle[2]=self.turtle[2]+alpha
    def setDirection(self,alpha): 
        """Drehen der Turtle

        alpha ist der Winkel gegen die Rechtsachse"""
        assert isinstance(alpha,int) or isinstance(alpha,float)
        self.turtle[2]=alpha
    def setPosition(self,x,y): 
        """Setzt die Position der Turtle ohne Zeichnen

        x,y sind die Zielkoordinaten (in Pixeln)"""
        self.turtle[0]=x
        self.turtle[1]=y
    def moveTo(self,x,y): 
        """Bewegt die Turtle

        x,y sind die Zielkoordinaten (in Pixeln)"""
        if isinstance(x,float): x=int(x)
        if isinstance(y,float): y=int(y)
        assert isinstance(x,int)
        assert isinstance(y,int)
        if self.turtle[3]:
            self.BM.drawLine(self.turtle[0],self.turtle[1],x,y,self.turtle[4])
        self.turtle[0]=x
        self.turtle[1]=y        
    def forward(self,L):
        """Bewegt die Turtle

        L ist die Distanz in Pixeln"""
        assert isinstance(L,int) or isinstance(L,float)
        [x0,y0,alpha,pd,col]=self.turtle
        x1=x0+L*math.cos(alpha/180.0*math.pi)
        y1=y0+L*math.sin(alpha/180.0*math.pi)
        self.turtle[0]=x1
        self.turtle[1]=y1
        if pd:
            self.BM.drawLine(x0,y0,x1,y1,col)
    def backward(self,L):
        """Bewegt die Turtle rueckwaerts

        L ist die Distanz in Pixeln"""
        assert isinstance(L,int) or isinstance(L,float)
        [x0,y0,alpha,pd,col]=self.turtle
        x1=x0-L*math.cos(-alpha/180.0*math.pi)
        y1=y0-L*math.sin(-alpha/180.0*math.pi)
        self.turtle[0]=x1
        self.turtle[1]=y1
        if self.turtle[3]:
            self.BM.drawLine(x0,y0,x1,y1,col)
    def penUp(self): 
        """Schaltet den Stift der Turtle aus"""
        self.turtle[3]=False
    def penDown(self): 
        """Schaltet den Stift der Turtle an"""
        self.turtle[3]=True
    def setPenColor(self,col): 
        """Setzt die Farbe der Turtle
        
        Die Farbe kann ein RGB-Tupel wie [255,0,0] oder ein Wort wie 'red' sein"""
        self.turtle[4]=mkQColNum(col)
    def setColor(self,col): 
        """Setzt die Farbe der Turtle (wie setPenColor)
        
        Die Farbe kann ein RGB-Tupel wie [255,0,0] oder ein Wort wie 'red' sein"""
        self.turtle[4]=mkQColNum(col)




# Item-bases graphics
class SWGraphics(QtGui.QGraphicsView):
    def __init__(self, width=200,height=200, container=None):
        QtGui.QGraphicsView.__init__(self)
        self.scene=QtGui.QGraphicsScene()
        self.scene.setSceneRect(0,0,width,height)
        self.setScene(self.scene)
        self.viewport=[-10,10,-10,10]
        self.penColor=mkQCol("black")
        self.setRenderHint(QtGui.QPainter.Antialiasing)
        if container==None: self.layout = TheCursor
        else: self.layout =container
        self.layout.addWidget(self)
    def setPenColor(self,col): self.penColor=mkQCol(col)
    def getDim(self): return [self.scene.width(),self.scene.height()]
    def setViewport(self, vp): self.viewport=vp
    def xW2S(self,x): return int(self.scene.width()*(x-self.viewport[0])/
                                    float((self.viewport[1]-self.viewport[0])))
    def yW2S(self,y): return int(self.scene.height()*(1.0-(y-self.viewport[2])/
                                    float((self.viewport[3]-self.viewport[2]))))
    def xS2W(self,x): 
        return self.viewport[0]+x/float(self.scene.width())*(self.viewport[1]-self.viewport[0])
    def yS2W(self,y): 
        return self.viewport[2]+(self.scene.height()-y)/float(self.scene.height())*(self.viewport[3]-self.viewport[2])
    # Die 0-Varianten seten Radien u.ae. um
    def xW2S0(self,x): return int(self.scene.width()*x/float(self.viewport[1]-self.viewport[0]))
    def yW2S0(self,y): return int(self.scene.height()*y/float(self.viewport[3]-self.viewport[2]))
    def xS2W0(self,x): return x/float(self.scene.width())*(self.viewport[1]-self.viewport[0])
    def yS2W0(self,y): return (self.scene.height()-y)/float(self.scene.height())*(self.viewport[3]-self.viewport[2])
    def minimumSizeHint(self): return QtCore.QSize(self.scene.width(), self.scene.height())
    def sizeHint(self): return QtCore.QSize(self.scene.width(), self.scene.height())
    def add(self,obj): self.scene.addItem(obj)
    def addSWPixelImage(self,x,y,pixmap): # pixmap kann String (Datei) sein  
        pm=SWPixelImage(self,[x,y],pixmap)
        return pm
    def addLine(self,x1,y1,x2,y2,color=None):
        L=SWLine(self,[x1,y1,x2,y2])
        if color==None: L.setColor(mkQCol("black"))
        else: L.setColor(color)
        return L
    def addRectangle(self,x,y,xd,yd,color=None,fillcolor=None):  
        re=SWRectangle(self,[x,y,xd,yd])
        re.setColor(color)
        re.setFillColor(fillcolor)
        return re
    def addRectangleW(self,x,y,xd,yd,color=None,fillcolor=None):  
        re=SWRectangle(self,[x,y,xd,yd],color=color,fillcolor=fillcolor)
        re.setColor(color)
        re.setFillColor(fillcolor)
        re.setCoordsW(x,y,xd,yd)
        return re
    def addEllipse(self,x,y,xd,yd,color=mkQCol("black"),fillcolor=None):  
        e=SWEllipse(self,[x,y,xd,yd])
        e.setColor(color)
        e.setFillColor(fillcolor)
        return e
    def addEllipseW(self,x,y,xd,yd,color=mkQCol("black"),fillcolor=None):  
        e=SWEllipse(self,[0,0,0,0])
        e.setColor(color)
        e.setFillColor(fillcolor)
        e.setCoordsW(x,y,xd,yd)
        return e
    def addCircle(self,x,y,r,color=mkQCol("black"),fillcolor=None):  
        e=SWEllipse(self,[x,y,r])
        e.setColor(color)
        e.setFillColor(fillcolor)
        return e
    def addCircleW(self,x,y,r,color=mkQCol("black"),fillcolor=None):  
        e=SWEllipse(self,[10,10,1])
        e.setColor(color)
        e.setFillColor(fillcolor)
        e.setCoordsW(x,y,r)
        return e
    def addPolygon(self,coords): 
        poly=QtGui.QPolygonF(map(lambda p: QtCore.QPointF(p[0],p[1]), coords))
        return self.scene.addPolygon(poly)
    def addFilledPolygon(self,coords): 
        poly=QtGui.QPolygonF(map(lambda p: QtCore.QPointF(p[0],p[1]), coords))
        return self.scene.addPolygon(poly,pen=self.pen,brush=self.brush)
    def addText(self,x,y,s): 
        assert isinstance(s,str)
        assert isinstance(x,int) or isinstance(x,float)
        t=self.scene.addText(s)
        t.setPos(x,y)
        return t
    def removeItem(self,obj): self.scene.removeItem(obj)
    def clear(self): 
        self.scene.clear()
        self.scene.update()
    def update(self): 
        self.scene.update()




#----------------------------------------------------------------------------


class SWEllipse(QtGui.QGraphicsEllipseItem):
    # Die Koordinaten sind Mittelpunkte und Radien
    def __init__(self,SWG,coords,mousePressCommand=None, mouseReleaseCommand=None,
                 mouseDragCommand=None):
        self.SWG=SWG
        self.scene=SWG.scene
        self.setMousePressCommand(mousePressCommand)
        self.setMouseReleaseCommand(mouseReleaseCommand)
        self.setMouseDragCommand(mouseDragCommand)
        self.autoDrag=False
        self.col=mkQCol("black")
        self.fillcolor=None
        self.filled=False
        if len(coords)==3: coords=coords+[coords[-1]]                
        QtGui.QGraphicsEllipseItem.__init__(self,coords[0]-coords[2],coords[1]-coords[3],
                                            2*coords[2],2*coords[3],scene=SWG.scene,parent=None)
        [self.X,self.Y,self.Rx,self.Ry]=coords
        self.coords=coords
        self.coordsW=[]
        self.calcWfromS()        
    # Abschnitt fuer alle gleich   ---------------------- Beginn
        self.collissionCommand=None
    def setCollissionCommand(self,cmd): 
        self.collissionCommand=cmd
    def setAutoDrag(self,yesNo): self.autoDrag=yesNo
    def setColor(self,col): 
        if col==None:
            self.setPen(Qt.QColor(0,0,0,0))
        else:
            self.col=mkQCol(col)
            self.setPen(self.col)
    def setFillColor(self,col): # None erlaubt
        if col!=None: 
            self.fillcolor=mkQCol(col)
            self.filled=True
            self.setBrush(self.fillcolor)
            self.brush().setStyle(1)
        else: 
            self.filled=False
            self.setBrush(Qt.QColor(0,0,0,0))
    def setFilled(self,b): 
        self.filled=b
    def setMousePressCommand(self,s): self.mousePressCommand=s
    def setMouseReleaseCommand(self,s): self.mouseReleaseCommand=s
    def setMouseDragCommand(self,s): self.mouseDragCommand=s
    def setMouseMoveCommand(self,s): self.mouseDragCommand=s
    def mousePressEvent(self, event):
        if self.mousePressCommand!=None: 
            try:
                pos=map(int,[event.scenePos().x(),event.scenePos().y()])
                [event.X,event.Y]=pos
                [event.XW,event.YW]=[self.SWG.xS2W(pos[0]),self.SWG.yS2W(pos[1])]
                self.mousePressCommand(self,event)
            except: print "Fehler in mousePressEvent"
    def mouseReleaseEvent(self, event):
        if self.mouseReleaseCommand!=None: 
            try:
                pos=map(int,[event.scenePos().x(),event.scenePos().y()])
                [event.X,event.Y]=pos
                [event.XW,event.YW]=[self.SWG.xS2W(pos[0]),self.SWG.yS2W(pos[1])]
                self.mouseReleaseCommand(self,event)
            except: print "Fehler in mouseReleaseEvent"
    def mouseMoveEvent(self, event):
        #if self.autoDrag: print "AutoDragging to ", [event.scenePos().x(),event.scenePos().y()]
        if self.autoDrag: 
            #print "Autodrag from ",self.coords," to ", map(int,[event.scenePos().x(),event.scenePos().y()])
            apply(self.setCenter,map(int,[event.scenePos().x(),event.scenePos().y()]))
        if self.mouseDragCommand!=None: 
            try:
                pos=map(int,[event.scenePos().x(),event.scenePos().y()])
                [event.X,event.Y]=pos
                [event.XW,event.YW]=[self.SWG.xS2W(pos[0]),self.SWG.yS2W(pos[1])]
                self.mouseDragCommand(self,event)
            except: print "Fehler in mouseMoveEvent"
            self.SWG.update()
    # Abschnitt fuer alle gleich   ---------------------- Ende
    def calcWfromS(self): 
        self.coordsW=[self.SWG.xS2W(self.coords[0]),self.SWG.yS2W(self.coords[1]),
                      self.SWG.xS2W0(self.coords[2]),self.SWG.yS2W0(self.coords[3])]
    def calcSfromW(self): 
        self.coords=[self.SWG.xW2S(self.coordsW[0]),self.SWG.yW2S(self.coordsW[1]),
                     self.SWG.xW2S0(self.coordsW[2]),self.SWG.yW2S0(self.coordsW[3])]
        [self.X,self.Y,self.Rx,self.Ry]=self.coords
    def getCenter(self): return self.coords[0:2]
    def getCenterW(self): return self.coordsW[0:2]
    def getX(self): return self.coords[0]
    def getY(self): return self.coords[1]
    def getXW(self): return self.coordsW[0]
    def getYW(self): return self.coordsW[1]
    def moveTo(self,x,y): self.setCenter(x,y)
    def moveToW(self,x,y): self.setCenterW(x,y)
    def move(self,dx,dy): self.setCenter(self.coords[0]+dx,self.coords[1]+dy)
    def moveW(self,dx,dy): self.setCenterW(self.coordsW[0]+dx,self.coordsW[1]+dy)
    def setCenter(self,x,y): 
        self.setCoords([x,y,self.Rx,self.Ry])
    def setCenterW(self,x,y): 
        self.setCoordsW([x,y,self.coordsW[2],self.coordsW[3]])
    def setRadius(self,r): self.setCoords([self.coords[0],self.coords[0],r,r])
    def setRadiusW(self,r): self.setCoordsW([self.coordsW[0],self.coordsW[0],r,r])
    def setRadii(self,rx,ry): self.setCoords([self.coords[0],self.coords[0],rx,ry])
    def setRadiiW(self,rx,ry): self.setCoordsW([self.coordsW[0],self.coordsW[1],rx,ry])
    def setCoords(self,*args):
        if len(args)==3: 
            coords=list(args)
            coords=coords+[coords[-1]]
        else:
            if len(args)==4: coords=list(args)
            else: 
                if len(args)==2: coords=args+self.coords[2:]
                else: coords=args[0]
        coords=map(int,coords)
        [self.X,self.Y,self.Rx,self.Ry]=self.coords
        self.coords=coords
        self.calcWfromS()
        re=[self.coords[0]-self.coords[2],
                     self.coords[1]-self.coords[2],
                        2*self.coords[2], 2*self.coords[3]]
        #self.setRect(re)
        self.setRect(apply(self.mapRectFromScene,re))
        self.handleCollide()
    def setCoordsW(self,*args):
        if len(args)==3: 
            coordsW=list(args)
            coordsW=coordsW+[coordsW[-1]]
        else:
            if len(args)==4: coordsW=list(args)
            else: coordsW=args[0]
        self.coordsW=coordsW
        self.calcSfromW()
        re=[self.coords[0]-self.coords[2],
                     self.coords[1]-self.coords[2],
                        2*self.coords[2], 2*self.coords[3]]
        #self.setRect(re)
        self.setRect(apply(self.mapRectFromScene,re))
        self.handleCollide()
    def handleCollide(self):
        if self.collissionCommand==None: return
        cl=self.collidingItems()
        if cl==[]: return
        self.collissionCommand(cl)


class SWRectangle(QtGui.QGraphicsRectItem):
    # Die Koordinaten sind Mittelpunkte und Radien
    def __init__(self,SWG,coords,mousePressCommand=None, mouseReleaseCommand=None,
                 mouseDragCommand=None):
        self.SWG=SWG
        self.scene=SWG.scene
        self.setMousePressCommand(mousePressCommand)
        self.setMouseReleaseCommand(mouseReleaseCommand)
        self.setMouseDragCommand(mouseDragCommand)
        self.autoDrag=False
        self.col=mkQCol("black")
        self.fillcolor=None
        self.filled=False
        if len(coords)==3: coords=coords+[coords[-1]]                
        QtGui.QGraphicsRectItem.__init__(self,coords[0]-coords[2],coords[1]-coords[3],
                                            2*coords[2],2*coords[3],scene=SWG.scene,parent=None)
        [self.X,self.Y,self.Rx,self.Ry]=coords
        self.coords=coords
        self.coordsW=[]
        self.calcWfromS()        
    # Abschnitt fuer alle gleich   ---------------------- Beginn
        self.collissionCommand=None
    def setCollissionCommand(self,cmd): 
        self.collissionCommand=cmd
    def setAutoDrag(self,yesNo): self.autoDrag=yesNo
    def setColor(self,col): 
        if col==None:
            self.setPen(Qt.QColor(0,0,0,0))
        else:
            self.col=mkQCol(col)
            self.setPen(self.col)
    def setFillColor(self,col): # None erlaubt
        if col!=None: 
            self.fillcolor=mkQCol(col)
            self.filled=True
            self.setBrush(self.fillcolor)
            self.brush().setStyle(1)
        else: 
            self.filled=False
            self.setBrush(Qt.QColor(0,0,0,0))
    def setFilled(self,b): 
        self.filled=b
    def setMousePressCommand(self,s): self.mousePressCommand=s
    def setMouseReleaseCommand(self,s): self.mouseReleaseCommand=s
    def setMouseDragCommand(self,s): self.mouseDragCommand=s
    def setMouseMoveCommand(self,s): self.mouseDragCommand=s
    def mousePressEvent(self, event):
        if self.mousePressCommand!=None: 
            try:
                pos=map(int,[event.scenePos().x(),event.scenePos().y()])
                [event.X,event.Y]=pos
                [event.XW,event.YW]=[self.SWG.xS2W(pos[0]),self.SWG.yS2W(pos[1])]
                self.mousePressCommand(self,event)
            except: print "Fehler in mousePressEvent"
    def mouseReleaseEvent(self, event):
        if self.mouseReleaseCommand!=None: 
            try:
                pos=map(int,[event.scenePos().x(),event.scenePos().y()])
                [event.X,event.Y]=pos
                [event.XW,event.YW]=[self.SWG.xS2W(pos[0]),self.SWG.yS2W(pos[1])]
                self.mouseReleaseCommand(self,event)
            except: print "Fehler in mouseReleaseEvent"
    def mouseMoveEvent(self, event):
        #if self.autoDrag: print "AutoDragging to ", [event.scenePos().x(),event.scenePos().y()]
        if self.autoDrag: 
            #print "Autodrag from ",self.coords," to ", map(int,[event.scenePos().x(),event.scenePos().y()])
            apply(self.setCenter,map(int,[event.scenePos().x(),event.scenePos().y()]))
        if self.mouseDragCommand!=None: 
            try:
                pos=map(int,[event.scenePos().x(),event.scenePos().y()])
                [event.X,event.Y]=pos
                [event.XW,event.YW]=[self.SWG.xS2W(pos[0]),self.SWG.yS2W(pos[1])]
                self.mouseDragCommand(self,event)
            except: print "Fehler in mouseMoveEvent"
            self.SWG.update()
    # Abschnitt fuer alle gleich   ---------------------- Ende
    def calcWfromS(self): 
        self.coordsW=[self.SWG.xS2W(self.coords[0]),self.SWG.yS2W(self.coords[1]),
                      self.SWG.xS2W0(self.coords[2]),self.SWG.yS2W0(self.coords[3])]
    def calcSfromW(self): 
        self.coords=[self.SWG.xW2S(self.coordsW[0]),self.SWG.yW2S(self.coordsW[1]),
                     self.SWG.xW2S0(self.coordsW[2]),self.SWG.yW2S0(self.coordsW[3])]
        [self.X,self.Y,self.Rx,self.Ry]=self.coords
    def getCenter(self): return self.coords[0:2]
    def getCenterW(self): return self.coordsW[0:2]
    def getX(self): return self.coords[0]
    def getY(self): return self.coords[1]
    def getXW(self): return self.coordsW[0]
    def getYW(self): return self.coordsW[1]
    def getWidth(self): return 2*self.coords[2]
    def getHeight(self): return 2*self.coords[3]
    def getWidthW(self): return 2*self.coordsW[2]
    def getHeightW(self): return 2*self.coordsW[3]
    def setWidth(self,w): self.setCoords(self.coords[0],self.coords[1],w/2,self.coords[3])
    def setHeight(self,h): self.setCoords(self.coords[0],self.coords[1],self.coords[2],h/2)
    def setWidthW(self,w): 
        self.setCoordsW(self.coordsW[0],self.coordsW[1],w/2,self.coordsW[3])
    def setHeightW(self,h): 
        self.setCoordsW(self.coordsW[0],self.coordsW[1],self.coordsW[2],h/2)
    def moveTo(self,x,y): self.setCenter(x,y)
    def moveToW(self,x,y): self.setCenterW(x,y)
    def move(self,dx,dy): self.setCenter(self.coords[0]+dx,self.coords[1]+dy)
    def moveW(self,dx,dy): self.setCenterW(self.coordsW[0]+dx,self.coordsW[1]+dy)
    def setCenter(self,x,y): 
        self.setCoords([x,y,self.Rx,self.Ry])
    def setCenterW(self,x,y): 
        self.setCoordsW([x,y,self.coordsW[2],self.coordsW[3]])
    def setPos(self,x,y): self.setCenter(x-self.coords[2],y-self.coords[3])
    def setPosW(self,x,y): self.setCenterW(x-self.coordsW[2],y-self.coordsW[3])
    def setCoords(self,*args):
        if len(args)==3: 
            coords=list(args)
            coords=coords+[coords[-1]]
        else:
            if len(args)==4: coords=list(args)
            else: 
                if len(args)==2: coords=args+self.coords[2:]
                else: coords=args[0]
        coords=map(int,coords)
        [self.X,self.Y,self.Rx,self.Ry]=self.coords
        self.coords=coords
        self.calcWfromS()
        re=[self.coords[0]-self.coords[2],
                     self.coords[1]-self.coords[2],
                        2*self.coords[2], 2*self.coords[3]]
        #self.setRect(re)
        self.setRect(apply(self.mapRectFromScene,re))
        self.handleCollide()
    def setCoordsW(self,*args):
        if len(args)==3: 
            coordsW=list(args)
            coordsW=coordsW+[coordsW[-1]]
        else:
            if len(args)==4: coordsW=list(args)
            else: coordsW=args[0]
        self.coordsW=coordsW
        self.calcSfromW()
        re=[self.coords[0]-self.coords[2],
                     self.coords[1]-self.coords[2],
                        2*self.coords[2], 2*self.coords[3]]
        #self.setRect(re)
        self.setRect(apply(self.mapRectFromScene,re))
        self.handleCollide()
    def handleCollide(self):
        if self.collissionCommand==None: return
        cl=self.collidingItems()
        if cl==[]: return
        self.collissionCommand(cl)



class SWLine(QtGui.QGraphicsLineItem):
    # Die Koordinaten sind Mittelpunkte und Radien
    def __init__(self,SWG,coords,mousePressCommand=None, mouseReleaseCommand=None,
                 mouseDragCommand=None,color=None):
        self.SWG=SWG
        self.scene=SWG.scene
        self.setMousePressCommand(mousePressCommand)
        self.setMouseReleaseCommand(mouseReleaseCommand)
        self.setMouseDragCommand(mouseDragCommand)
        self.autoDrag=False
        if color==None: self.color=mkQCol("black")
        else: self.color=color
        QtGui.QGraphicsLineItem.__init__(self,coords[0],coords[1],coords[2],coords[3],scene=SWG.scene,parent=None)
        [self.x1,self.y1,self.x2,self.y2]=coords
        self.coords=coords
        self.coordsW=[]
        self.calcWfromS()        
    # Abschnitt fuer alle gleich   ---------------------- Beginn
        self.collissionCommand=None
    def setCollissionCommand(self,cmd): 
        self.collissionCommand=cmd
    def setAutoDrag(self,yesNo): self.autoDrag=yesNo
    def setColor(self,col): 
        self.col=mkQCol(col)
        self.setPen(self.col)
    def setMousePressCommand(self,s): self.mousePressCommand=s
    def setMouseReleaseCommand(self,s): self.mouseReleaseCommand=s
    def setMouseDragCommand(self,s): self.mouseDragCommand=s
    def setMouseMoveCommand(self,s): self.mouseDragCommand=s
    def mousePressEvent(self, event):
        if self.mousePressCommand!=None: 
            try:
                pos=map(int,[event.scenePos().x(),event.scenePos().y()])
                [event.X,event.Y]=pos
                [event.XW,event.YW]=[self.SWG.xS2W(pos[0]),self.SWG.yS2W(pos[1])]
                self.mousePressCommand(self,event)
            except: print "Fehler in mousePressEvent"
    def mouseReleaseEvent(self, event):
        if self.mouseReleaseCommand!=None: 
            try:
                pos=map(int,[event.scenePos().x(),event.scenePos().y()])
                [event.X,event.Y]=pos
                [event.XW,event.YW]=[self.SWG.xS2W(pos[0]),self.SWG.yS2W(pos[1])]
                self.mouseReleaseCommand(self,event)
            except: print "Fehler in mouseReleaseEvent"
    def mouseMoveEvent(self, event):
        #if self.autoDrag: print "AutoDragging to ", [event.scenePos().x(),event.scenePos().y()]
        if self.autoDrag: 
            #print "Autodrag from ",self.coords," to ", map(int,[event.scenePos().x(),event.scenePos().y()])
            apply(self.setCenter,map(int,[event.scenePos().x(),event.scenePos().y()]))
        if self.mouseDragCommand!=None: 
            try:
                pos=map(int,[event.scenePos().x(),event.scenePos().y()])
                [event.X,event.Y]=pos
                [event.XW,event.YW]=[self.SWG.xS2W(pos[0]),self.SWG.yS2W(pos[1])]
                self.mouseDragCommand(self,event)
            except: print "Fehler in mouseMoveEvent"
            self.SWG.update()
    # Abschnitt fuer alle gleich   ---------------------- Ende
    def calcWfromS(self): 
        self.coordsW=[self.SWG.xS2W(self.coords[0]),self.SWG.yS2W(self.coords[1]),
                      self.SWG.xS2W(self.coords[2]),self.SWG.yS2W(self.coords[3])]
    def calcSfromW(self): 
        self.coords=[self.SWG.xW2S(self.coordsW[0]),self.SWG.yW2S(self.coordsW[1]),
                     self.SWG.xW2S(self.coordsW[2]),self.SWG.yW2S(self.coordsW[3])]
        [self.x1,self.y1,self.x2,self.y2]=self.coords
    def getCenter(self): return [(self.coords[0]+self.coords[2])/2,(self.coords[1]+self.coords[3])/2]
    def getCenterW(self): return [(self.coordsW[0]+self.coordsW[2])/2,(self.coordsW[1]+self.coordsW[3])/2]
    def moveTo(self,x,y): self.setCenter(x,y)
    def moveToW(self,x,y): self.setCenterW(x,y)
    def move(self,dx,dy): 
        self.setCoords([self.coords[0]+dx,self.coords[1]+dy,
                             self.coords[2]+dx,self.coords[3]+dy])
    def moveW(self,dx,dy): 
        self.setCoordsW([self.coordsW[0]+dx,self.coordsW[1]+dy,
                             self.coordsW[2]+dx,self.coordsW[3]+dy])
    def setCenter(self,x,y):
        [x1,y1,x2,y2]=self.coords
        [dx,dy]=[x2-x1,y2-y1]
        self.setCoords([x-dx/2,y-dy/2,x+dx/2,y+dy/2])
    def setCenterW(self,x,y):
        [x1,y1,x2,y2]=self.coordsW
        [dx,dy]=[x2-x1,y2-y1]
        self.setCoordsW([x-dx/2,y-dy/2,x+dx/2,y+dy/2])
    def setPos(self,x,y): self.setCenter(x,y)
    def setPosW(self,x,y): self.setCenterW(x,y)
    def setCoords(self,*args):
        if len(args)==4: coords=list(args)
        else: 
            if len(args)==2: coords=args+self.coords[2:]
            else: coords=args[0]
        coords=map(int,coords)
        [self.X,self.Y,self.Rx,self.Ry]=self.coords
        self.coords=coords
        self.calcWfromS()
        self.setLine(self.coords[0],self.coords[1],
                     self.coords[2],self.coords[3])
        self.handleCollide()
    def setCoordsW(self,*args):
        if len(args)==4: coordsW=list(args)
        else: coordsW=args[0]
        self.coordsW=coordsW
        self.calcSfromW()
        self.setLine(self.coords[0],self.coords[1],
                     self.coords[2],self.coords[3])
        self.handleCollide()
    def handleCollide(self):
        if self.collissionCommand==None: return
        cl=self.collidingItems()
        if cl==[]: return
        self.collissionCommand(cl)













class SWPixelImage(QtGui.QGraphicsPixmapItem):
    # Die Koordinaten sind Mittelpunkte und Radien
    def __init__(self,SWG,coords,pixmap,mousePressCommand=None, mouseReleaseCommand=None,
                 mouseDragCommand=None):
        self.SWG=SWG
        self.scene=SWG.scene
        self.setMousePressCommand(mousePressCommand)
        self.setMouseReleaseCommand(mouseReleaseCommand)
        self.setMouseDragCommand(mouseDragCommand)
        self.autoDrag=False
        self.image=None
        if type(pixmap)==str: # Erzeugung aus Datei mit Namen
            pm=QtGui.QPixmap()
            self.image=QtGui.QImage(pixmap)
            if len(coords)==2: coords=coords+[self.image.width(),self.image.height()]
            pm.convertFromImage(self.image)
            pixmap=pm
        if not(isinstance(pixmap,QtGui.QPixmap)):
            raise Exception("QPixMap required")
        self.pixmap=pixmap
        QtGui.QGraphicsPixmapItem.__init__(self,pixmap,scene=SWG.scene,parent=None)
        self.coords=coords
        self.coordsW=[]
        self.calcWfromS()        
        self.setOffset(self.coords[0],self.coords[1])
    # Abschnitt fuer alle gleich   ---------------------- Beginn
        self.collissionCommand=None
    def setCollissionCommand(self,cmd): 
        self.collissionCommand=cmd
    def setAutoDrag(self,yesNo): self.autoDrag=yesNo
    def setMousePressCommand(self,s): self.mousePressCommand=s
    def setMouseReleaseCommand(self,s): self.mouseReleaseCommand=s
    def setMouseDragCommand(self,s): self.mouseDragCommand=s
    def setMouseMoveCommand(self,s): self.mouseDragCommand=s
    def mousePressEvent(self, event):
        if self.mousePressCommand!=None: 
            try:
                pos=map(int,[event.scenePos().x(),event.scenePos().y()])
                [event.X,event.Y]=pos
                [event.XW,event.YW]=[self.SWG.xS2W(pos[0]),self.SWG.yS2W(pos[1])]
                self.mousePressCommand(self,event)
            except: print "Fehler in mousePressEvent"
    def mouseReleaseEvent(self, event):
        if self.mouseReleaseCommand!=None: 
            try:
                pos=map(int,[event.scenePos().x(),event.scenePos().y()])
                [event.X,event.Y]=pos
                [event.XW,event.YW]=[self.SWG.xS2W(pos[0]),self.SWG.yS2W(pos[1])]
                self.mouseReleaseCommand(self,event)
            except: print "Fehler in mouseReleaseEvent"
    def mouseMoveEvent(self, event):
        #if self.autoDrag: print "AutoDragging to ", [event.scenePos().x(),event.scenePos().y()]
        if self.autoDrag: 
            #print "Autodrag from ",self.coords," to ", map(int,[event.scenePos().x(),event.scenePos().y()])
            apply(self.setCenter,map(int,[event.scenePos().x(),event.scenePos().y()]))
        if self.mouseDragCommand!=None: 
            try:
                pos=map(int,[event.scenePos().x(),event.scenePos().y()])
                [event.X,event.Y]=pos
                [event.XW,event.YW]=[self.SWG.xS2W(pos[0]),self.SWG.yS2W(pos[1])]
                self.mouseDragCommand(self,event)
            except: print "Fehler in mouseMoveEvent"
            self.SWG.update()
    # Abschnitt fuer alle gleich   ---------------------- Ende
    def calcWfromS(self): 
        self.coordsW=[self.SWG.xS2W(self.coords[0]),self.SWG.yS2W(self.coords[1]),
                      self.SWG.xS2W0(self.coords[2]),self.SWG.yS2W0(self.coords[3])]
    def calcSfromW(self): 
        self.coords=[self.SWG.xW2S(self.coordsW[0]),self.SWG.yW2S(self.coordsW[1]),
                     self.SWG.xW2S0(self.coordsW[2]),self.SWG.yW2S0(self.coordsW[3])]
    def getCenter(self): return self.coords[0:2]
    def getCenterW(self): return self.coordsW[0:2]
    def getX(self): return self.coords[0]
    def getY(self): return self.coords[1]
    def getXW(self): return self.coordsW[0]
    def getYW(self): return self.coordsW[1]
    def getWidth(self): return self.coords[2]
    def getHeight(self): return self.coords[3]
    def getWidthW(self): return self.coordsW[2]
    def getHeightW(self): return self.coordsW[3]
    def moveTo(self,x,y): self.setCenter(x,y)
    def moveToW(self,x,y): self.setCenterW(x,y)
    def move(self,dx,dy): 
        self.setCoords([self.coords[0]+dx,self.coords[1]+dy,
                             self.coords[2],self.coords[3]])
    def moveW(self,dx,dy): 
        self.setCoordsW([self.coordsW[0]+dx,self.coordsW[1]+dy,
                             self.coordsW[2],self.coordsW[3]])
    def setCenter(self,x,y): 
        self.setCoords([x-self.coords[2]/2,y-self.coords[3]/2,self.coords[2],self.coords[3]])
    def setCenterW(self,x,y): 
        self.setCoordsW([x-self.coordsW[2]/2,y-self.coordsW[3]/2,
                         self.coordsW[2],self.coordsW[3]])
    def setPos(self,x,y): self.setCenter(x-self.coords[2]/2,y-self.coords[3]/2)
    def setPosW(self,x,y): self.setCenterW(x-self.coordsW[2]/2,y-self.coordsW[3]/2)
    def setCoords(self,*args):
        if len(args)==4: coords=list(args)
        else: 
            if len(args)==2: coords=args+self.coords[2:]
            else: coords=args[0]
        coords=map(int,coords)
        [self.X,self.Y,self.Rx,self.Ry]=self.coords
        self.coords=coords
        self.calcWfromS()
        #self.setOffset(self.coords[0],self.coords[1])
        re=self.coords
        nr=apply(self.mapRectFromScene,re)
        self.setOffset(nr.x(),nr.y())
        self.handleCollide()
    def setCoordsW(self,*args):
        if len(args)==4: coordsW=list(args)
        else: coordsW=args[0]
        self.coordsW=coordsW
        self.calcSfromW()
        #self.setOffset(self.coords[0],self.coords[1])
        re=self.coords
        nr=apply(self.mapRectFromScene,re)
        self.setOffset(nr.x(),nr.y())
        self.handleCollide()
    def handleCollide(self):
        if self.collissionCommand==None: return
        cl=self.collidingItems()
        if cl==[]: return
        self.collissionCommand(cl)




######################################################################

import traceback

class SWConsole(QtGui.QPlainTextEdit):
    def __init__(self, container=None, env={}, prompt='>>> ', 
                 startup_message='', parent=None):
        QtGui.QPlainTextEdit.__init__(self, parent)
        self.prompt = prompt
        self.history = []
        self.namespace = env
        self.construct = []
        if container==None: self.layout = TheCursor
        else: self.layout =container
        self.layout.addWidget(self)

        self.setGeometry(50, 75, 600, 400)
        self.setWordWrapMode(QtGui.QTextOption.WrapAnywhere)
        self.setUndoRedoEnabled(False)
        self.document().setDefaultFont(QtGui.QFont("monospace", 10, QtGui.QFont.Normal))
        self.showMessage(startup_message)

    def updateNamespace(self, namespace):
        self.namespace.update(namespace)

    def showMessage(self, message):
        self.appendPlainText(message)
        self.newPrompt()

    def newPrompt(self):
        if self.construct:
            prompt = '.' * len(self.prompt)
        else:
            prompt = self.prompt
        self.appendPlainText(prompt)
        self.moveCursor(QtGui.QTextCursor.End)

    def getCommand(self):
        doc = self.document()
        curr_line = unicode(doc.findBlockByLineNumber(doc.lineCount() - 1).text())
        curr_line = curr_line.rstrip()
        curr_line = curr_line[len(self.prompt):]
        return curr_line

    def setCommand(self, command):
        if self.getCommand() == command:
            return
        self.moveCursor(QtGui.QTextCursor.End)
        self.moveCursor(QtGui.QTextCursor.StartOfLine, QtGui.QTextCursor.KeepAnchor)
        for i in range(len(self.prompt)):
            self.moveCursor(QtGui.QTextCursor.Right, QtGui.QTextCursor.KeepAnchor)
        self.textCursor().removeSelectedText()
        self.textCursor().insertText(command)
        self.moveCursor(QtGui.QTextCursor.End)

    def getConstruct(self, command):
        if self.construct:
            prev_command = self.construct[-1]
            self.construct.append(command)
            if not prev_command and not command:
                ret_val = '\n'.join(self.construct)
                self.construct = []
                return ret_val
            else:
                return ''
        else:
            if command and command[-1] == (':'):
                self.construct.append(command)
                return ''
            else:
                return command

    def getHistory(self):
        return self.history

    def setHisory(self, history):
        self.history = history

    def addToHistory(self, command):
        if command and (not self.history or self.history[-1] != command):
            self.history.append(command)
        self.history_index = len(self.history)

    def getPrevHistoryEntry(self):
        if self.history:
            self.history_index = max(0, self.history_index - 1)
            return self.history[self.history_index]
        return ''

    def getNextHistoryEntry(self):
        if self.history:
            hist_len = len(self.history)
            self.history_index = min(hist_len, self.history_index + 1)
            if self.history_index < hist_len:
                return self.history[self.history_index]
        return ''

    def getCursorPosition(self):
        return self.textCursor().columnNumber() - len(self.prompt)

    def setCursorPosition(self, position):
        self.moveCursor(QtGui.QTextCursor.StartOfLine)
        for i in range(len(self.prompt) + position):
            self.moveCursor(QtGui.QTextCursor.Right)

    def runCommand(self):
        command = self.getCommand()
        self.addToHistory(command)

        command = self.getConstruct(command)
        if command:
            tmp_stdout = sys.stdout

            class stdoutProxy():
                def __init__(self, write_func):
                    self.write_func = write_func
                    self.skip = False

                def write(self, text):
                    if not self.skip:
                        stripped_text = text.rstrip('\n')
                        self.write_func(stripped_text)
                        QtCore.QCoreApplication.processEvents()
                    self.skip = not self.skip

            sys.stdout = stdoutProxy(self.appendPlainText)
            try:
                try:
                    G=globals()
                    for g in G: 
                        self.namespace[g]==G[g]
                    result = eval(command, self.namespace, self.namespace)
                    if result != None:
                        self.appendPlainText(repr(result))
                except SyntaxError:
                    exec command in self.namespace
            except SystemExit:
                self.close()
            except:
                traceback_lines = traceback.format_exc().split('\n')
                # Remove traceback mentioning this file, and a linebreak
                for i in (3,2,1,-1):
                    traceback_lines.pop(i)
                self.appendPlainText('\n'.join(traceback_lines))
            sys.stdout = tmp_stdout
        self.newPrompt()

    def keyPressEvent(self, event):
        if event.key() in (QtCore.Qt.Key_Enter, QtCore.Qt.Key_Return):
            self.runCommand()
            return
        if event.key() == QtCore.Qt.Key_Home:
            self.setCursorPosition(0)
            return
        if event.key() == QtCore.Qt.Key_PageUp:
            return
        elif event.key() in (QtCore.Qt.Key_Left, QtCore.Qt.Key_Backspace):
            if self.getCursorPosition() == 0:
                return
        elif event.key() == QtCore.Qt.Key_Up:
            self.setCommand(self.getPrevHistoryEntry())
            return
        elif event.key() == QtCore.Qt.Key_Down:
            self.setCommand(self.getNextHistoryEntry())
            return
        elif event.key() == QtCore.Qt.Key_D and event.modifiers() == QtCore.Qt.ControlModifier:
            self.close()
        super(SWConsole, self).keyPressEvent(event)

welcome_message = '''
   ---------------------------------------------------------------
     Welcome to a primitive Python interpreter.
   ---------------------------------------------------------------
'''



print "SWGui V1.2a - 24.8.2011"


#------------------------- Thread support
SWThreadList=[]

def ThreadExecute(fun,*args):
    """ThreadExecute(f,*argumente) fuehrt Funktion in neuem Thread aus
    
    Beispiel:  ThreadExecute(f) oder ThreadExecute(f,5,"text")
    f darf nicht due GUI veraendern!   """ 
    global SWThreadList
    t=SWThread(fun,list(args))
    SWThreadList.append(t)
    t.start()
class SWThread(QtCore.QThread):
    def __init__(self,fun,args):
        QtCore.QThread.__init__(self)
        self.fun=fun
        self.args=args
    def run(self):
        return apply(self.fun,self.args)




#SWinteract()
#TheMainWin.show()


